Bug 23281 - can not compile fortran 90 with openmpi
Summary: can not compile fortran 90 with openmpi
Status: RESOLVED FIXED
Alias: None
Product: Mageia
Classification: Unclassified
Component: RPM Packages (show other bugs)
Version: 6
Hardware: x86_64 Linux
Priority: Normal normal
Target Milestone: ---
Assignee: QA Team
QA Contact:
URL:
Whiteboard: MGA6-64-OK
Keywords: advisory, validated_update
Depends on:
Blocks:
 
Reported: 2018-07-04 09:45 CEST by eric gerbier
Modified: 2018-07-11 23:48 CEST (History)
7 users (show)

See Also:
Source RPM: openmpi-2.1.1-4.mga6.src.rpm
CVE:
Status comment:


Attachments
fortran f90 test code (604 bytes, text/plain)
2018-07-04 09:46 CEST, eric gerbier
Details

Description eric gerbier 2018-07-04 09:45:44 CEST
Description of problem:
can not compile fortran f90 with openmpi.
the code was compiling on mageia 6 in september 2017

Version-Release number of selected component (if applicable):
lib64openmpi-devel-2.1.1-4.mga6

How reproducible:


Steps to Reproduce:
1. download f90 mpi test code
2. run : mpif90 -o mpi_hello mpi_hello.f90
3. output is :
mpi_hello.f90:2:10:

       use mpi
          1
Erreur fatale: Can't open module file ‘mpi.mod’ for reading at (1): Aucun fichier ou dossier de ce type
compilation terminée.

how to fix :
the mpi.mod file is provided by lib64openmpi-devel-2.1.1-4.mga6 :
# rpm -ql lib64openmpi-devel-2.1.1-4.mga6 | grep  mpi.mod
/usr/lib/gcc/x86_64-mageia-linux-gnu/5.4.0/finclude/mpi.mod

but the path is strange : gcc version is 5.5.0, not 5.4.0

I just copy mpi.mod from /usr/lib/gcc/x86_64-mageia-linux-gnu/5.4.0/finclude/ to
/usr/lib/gcc/x86_64-mageia-linux-gnu/5.5.0/finclude/
and now the code is compiling well
Comment 1 eric gerbier 2018-07-04 09:46:48 CEST
Created attachment 10268 [details]
fortran f90 test code
eric gerbier 2018-07-04 09:48:39 CEST

Hardware: All => x86_64
CC: (none) => eric.gerbier

Comment 2 Marja Van Waes 2018-07-04 13:26:06 CEST
Assigning to the registered maintainer.

Assignee: bugsquad => eatdirt
CC: (none) => marja11

Comment 3 Thomas Backlund 2018-07-04 20:57:57 CEST
Ok, so it needs a rebuild for the gcc 5.5.0 update we did in:
http://advisories.mageia.org/MGASA-2018-0124.html

when we added the retpoline support to the compiler

CC: (none) => tmb

Comment 4 Chris Denice 2018-07-05 11:15:45 CEST
Yep, a recompilation is need. I can do it.

As an aside remark, the path is fine.

All fortran modules should be dependent of the gfortran/gcc version numbering as the fortran standard allows module API to be compiler dependent. So putting *.mod is /usr/include is a mistake.

The annoyance is indeed that they should be recompiled together with new version of the compiler, that's my mistake!

Cheers.
Comment 5 Chris Denice 2018-07-05 11:16:22 CEST
By the way, we may have the same issue with plplot and a few other packages providing fortran modules!
Comment 6 Chris Denice 2018-07-05 14:14:00 CEST
I have uploaded recompiled packages for Mageia 6 to be consistent with the update of gcc/gfortran.

There is no much to test, nothing has been changed in the packages. However, you should see module files (*.mod) installed within:

/usr/lib/gcc/x86_64-mageia-linux-gnu/5.5.0/finclude/

instead of

usr/lib/gcc/x86_64-mageia-linux-gnu/5.4.0/finclude/


Suggested advisory:
========================

Following gcc/gfortran update, various Fortran development packages have been recompiled to provide module files compatible with the updated gfortran version 5.5.0.


References:
http://advisories.mageia.org/MGASA-2018-0124.html
https://bugs.mageia.org/show_bug.cgi?id=23281
========================

Updated packages in core/updates_testing:
========================
lib64openmpi20-2.1.1-4.1.mga6
lib64openmpi-devel-2.1.1-4.1.mga6
lib64openmpi-static-devel-2.1.1-4.1.mga6
openmpi-2.1.1-4.1.mga6

java-plplot-5.12.0-4.1.mga6
lib64csiro0-5.12.0-4.1.mga6
lib64plplot14-5.12.0-4.1.mga6
lib64plplotada2-5.12.0-4.1.mga6
lib64plplotcxx13-5.12.0-4.1.mga6
lib64plplot-devel-5.12.0-4.1.mga6
lib64plplotf95_13-5.12.0-4.1.mga6
lib64plplotf95c12-5.12.0-4.1.mga6
lib64plplotqt2-5.12.0-4.1.mga6
lib64plplottcltk13-5.12.0-4.1.mga6
lib64plplottcltk_main1-5.12.0-4.1.mga6
lib64plplotwxwidgets1-5.12.0-4.1.mga6
lib64qsastime0-5.12.0-4.1.mga6
lib64tclmatrix10-5.12.0-4.1.mga6
lua-plplot-5.12.0-4.1.mga6
ocaml-plplot-5.12.0-4.1.mga6
octave-plplot-5.12.0-4.1.mga6
plplot-5.12.0-4.1.mga6
python-plplot-5.12.0-4.1.mga6

gnudl-healpix-3.31-2.1.mga6
healpix-3.31-2.1.mga6
healpix-debuginfo-3.31-2.1.mga6
lib64chealpix0-3.31-2.1.mga6
lib64chealpix-devel-3.31-2.1.mga6
lib64healpix0-3.31-2.1.mga6
lib64healpix_cxx0-3.31-2.1.mga6
lib64healpix_cxx-devel-3.31-2.1.mga6
lib64healpix-devel-3.31-2.1.mga6

lib64aspic0-0.3.2-4.1.mga6
lib64aspic-devel-0.3.2-4.1.mga6


Source RPMs: 
openmpi-2.1.1-4.1.mga6.src.rpm
plplot-5.12.0-4.1.mga6.src.rpm
healpix-3.31-2.1.mga6.src.rpm
aspic-0.3.2-4.1.mga6.src.rpm

CC: (none) => eatdirt
Assignee: eatdirt => qa-bugs

Comment 7 Len Lawrence 2018-07-05 19:56:36 CEST
Mageia 6, x86_64

Installed 33 of the 34 packages (debug repositories not enabled).

Tried compiling the helloworld program and saw the same result as in comment 0 (description).

$ mpif90 -o mpi_hello mpi_hello.f90
mpi_hello.f90:2:10:

       use mpi
          1
Fatal Error: Can't open module file ‘mpi.mod’ for reading at (1): No such file or directory
compilation terminated.

Updated everything without any problem and tried again.

$ mpif90 -o mpi_hello mpi_hello.f90
$ ./mpi_hello
Hello from task  0 on difda                                           
MASTER: Number of MPI tasks is:  1

Good to go for 64-bits assuming we do not need to run functionality tests for everything.

CC: (none) => tarazed25
Whiteboard: (none) => MGA6-64-OK

Comment 8 Chris Denice 2018-07-06 19:05:21 CEST
Thank you Len, yes, the debug package should not be tested:


healpix-debuginfo-3.31-2.1.mga6

It ended up in my list by copy-paste mistake, please ignore this package from my previous comment.

Cheers.
Comment 9 Dave Hodgins 2018-07-11 23:09:06 CEST
Advisory committed to svn. Validating the update.

Keywords: (none) => advisory, validated_update
CC: (none) => davidwhodgins, sysadmin-bugs

Comment 10 Mageia Robot 2018-07-11 23:48:12 CEST
An update for this issue has been pushed to the Mageia Updates repository.

https://advisories.mageia.org/MGAA-2018-0130.html

Resolution: (none) => FIXED
Status: NEW => RESOLVED


Note You need to log in before you can comment on or make changes to this bug.